uniform sampler2D HiResImage;
uniform sampler2D LoResImage;

uniform float MaxAdapt;
uniform float AvgAdapt;
uniform float MinAdapt;

varying vec2 vTexCoord;

void main(void)
{
	vec3 hires = texture2D(HiResImage, vTexCoord);
	vec3 lores = texture2D(LoResImage, vTexCoord);
	
	//screen mode sadly won't work as expected with hdr
	//gl_FragColor.rgb = (vec3(1.0, 1.0, 1.0) - lores) * hires + lores;

	gl_FragColor.rgb = ((hires * 0.7 + lores * 0.3) - MinAdapt) / (MaxAdapt - MinAdapt);
	gl_FragColor.rgb = pow(gl_FragColor.rgb, 1.0 + (AvgAdapt - 0.5));
	
	gl_FragColor.a = 1.0;
}
