uniform sampler2D DiffuseMap;
uniform sampler2D NormalMap;

varying vec2 vTexCoord;
varying vec3 vNormal;
varying vec3 vTangent;
varying vec3 vBinormal;

void main(void)
{
	vec3 lightDir = normalize(vec3(1.0, 1.0, 1.0));
	
	vec3 finalTangent = normalize(vTangent);
	vec3 finalBinormal = normalize(vBinormal);
	
	vec3 finalNormal = normalize(vNormal);	
	
	finalNormal += vTangent * (texture2D(NormalMap, vTexCoord).g * 2.0 - 1.0);
	finalNormal += vBinormal * (texture2D(NormalMap, vTexCoord).a * 2.0 - 1.0);
	
	finalNormal = normalize(finalNormal);

	float kD = clamp(dot(finalNormal, lightDir), 0.0, 1.0);
	
	vec3 half = normalize(lightDir + vec3(0, 0, 1));
	
	float kS = clamp(dot(finalNormal, half), 0.0, 1.0);
	kS = pow(kS, 80.0) * texture2D(NormalMap, vTexCoord).b;
	
	vec4 diffuseColor = texture2D(DiffuseMap, vTexCoord);
	
	gl_FragColor.rgb = diffuseColor.rgb * kD + vec3(2.0,1.9, 1.8) * kS;
	gl_FragColor.a = diffuseColor.a;
}
